/*
 * fische-3.2
 * Copyright (C) Marcel Ebmer 2009-2010 <marcel@26elf.at>
 *
 * fische-3.2 is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * fische-3.2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CONFIGURATION_H
#define CONFIGURATION_H

class Configuration
{
	private:
		static Configuration* ms_instance;

	private:
		Configuration();
		~Configuration();

	public:
		static Configuration* instance();
		void release();

	public:
		int width() const {
			return m_Width;
		}
		int height() const {
			return m_Height;
		}
		int processorCores() const {
			return m_ProcessorCores;
		}
		bool nervous() const {
			return m_IsNervous;
		}
		int frameDivisor() const {
			return m_FrameDivisor;
		}
		double aspectRatio() const {
			return m_AspectRatio;
		}
		void setGeometry (int);
		void setNervous (bool);
		void setFrameDivisor (int);
		void setAspectRatio (double);

	private:
		int					m_Width;
		int					m_Height;
		bool				m_IsNervous;
		int					m_ProcessorCores;
		int					m_FrameDivisor;
		double 				m_AspectRatio;

		int cpu_detect();

};

#endif // CONFIGURATION_H
