/*
 * fische-3.2
 * Copyright (C) Marcel Ebmer 2009-2010 <marcel@26elf.at>
 *
 * fische-3.2 is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * fische-3.2 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "xbmc/addons/include/xbmc_vis_dll.h"
#include "fishBMC.h"

FishBMC* p_fishbmc;

ADDON_STATUS Create (void* hdl, void* props)
{
	DEBUGOUT ("fishBMC Create");
	p_fishbmc = new FishBMC ( (struct VIS_PROPS*) props);
	return STATUS_NEED_SETTINGS;
}

extern "C" void Render()
{
	p_fishbmc->render();
}

extern "C" void Start (int iChannels, int iSamplesPerSec, int iBitsPerSample, const char* szSongName)
{
	DEBUGOUT ("fishBMC Start");
	p_fishbmc->start();
}

extern "C" void AudioData (const short* pAudioData, int iAudioDataLength, float *pFreqData, int iFreqDataLength)
{
	p_fishbmc->newData (pAudioData, iAudioDataLength * 4);
}


extern "C" void GetInfo (VIS_INFO* pInfo)
{
	DEBUGOUT ("fishBMC GetInfo");
	pInfo->bWantsFreq = false;
	pInfo->iSyncDelay = 0;
}

extern "C" unsigned int GetSubModules (char ***names)
{
	DEBUGOUT ("fishBMC GetSubModules");
	return 0;
}

extern "C" bool OnAction (long flags, const void *param)
{
	DEBUGOUT ("fishBMC OnAction");
	return false;
}

extern "C" unsigned int GetPresets (char ***presets)
{
	DEBUGOUT ("fishBMC GetPresets");
	return 0;
}

extern "C" unsigned GetPreset()
{
	DEBUGOUT ("fishBMC GetPreset");
	return 0;
}

extern "C" bool IsLocked()
{
	DEBUGOUT ("fishBMC IsLocked");
	return false;
}

extern "C" void Stop()
{
	DEBUGOUT ("fishBMC Stop");
	p_fishbmc->stop();
}

extern "C" void Destroy()
{
	DEBUGOUT ("fishBMC Destroy");
	delete p_fishbmc;
}

extern "C" bool HasSettings()
{
	DEBUGOUT ("fishBMC HasSettings");
	return false;
}

extern "C" ADDON_STATUS GetStatus()
{
	DEBUGOUT ("fishBMC GetStatus");
	return STATUS_OK;
}

extern "C" unsigned int GetSettings (StructSetting ***sSet)
{
	DEBUGOUT ("fishBMC GetSettings");
	return 0;
}

extern "C" void FreeSettings()
{
	DEBUGOUT ("fishBMC FreeSettings");
}

extern "C" ADDON_STATUS SetSetting (const char *strSetting, const void* value)
{
	DEBUGOUT ("fishBMC SetSetting");
	Configuration* config = Configuration::instance();

	if (!strSetting || !value)
		return STATUS_UNKNOWN;
	if (!strncmp (strSetting, "nervous", 7)) {
		bool nervous = * ( (bool*) value);
		config->setNervous (nervous);
	} else if (!strncmp (strSetting, "detail", 6)) {
		int detail = * ( (int*) value);
		int size = 128;
		while (detail--) {
			size *= 2;
		}
		config->setGeometry (size);
	} else if (!strncmp (strSetting, "divisor", 7)) {
		int divisor = * ( (int*) value);
		int skip = 8;
		while (divisor--) {
			skip /= 2;
		}
		config->setFrameDivisor (skip);
	}
	return STATUS_OK;
}
